/* Settings.c generated by valac 0.41.91, the Vala compiler
 * generated from Settings.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2013-2014 Audience Developers (http://launchpad.net/pantheon-chat)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.

 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 * Authored by: Tom Beckmann <tomjonabc@gmail.com>
 */


#include <glib.h>
#include <glib-object.h>
#include <granite.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>


#define AUDIENCE_TYPE_SETTINGS (audience_settings_get_type ())
#define AUDIENCE_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), AUDIENCE_TYPE_SETTINGS, AudienceSettings))
#define AUDIENCE_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), AUDIENCE_TYPE_SETTINGS, AudienceSettingsClass))
#define AUDIENCE_IS_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), AUDIENCE_TYPE_SETTINGS))
#define AUDIENCE_IS_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), AUDIENCE_TYPE_SETTINGS))
#define AUDIENCE_SETTINGS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), AUDIENCE_TYPE_SETTINGS, AudienceSettingsClass))

typedef struct _AudienceSettings AudienceSettings;
typedef struct _AudienceSettingsClass AudienceSettingsClass;
typedef struct _AudienceSettingsPrivate AudienceSettingsPrivate;
enum  {
	AUDIENCE_SETTINGS_0_PROPERTY,
	AUDIENCE_SETTINGS_MOVE_WINDOW_PROPERTY,
	AUDIENCE_SETTINGS_KEEP_ASPECT_PROPERTY,
	AUDIENCE_SETTINGS_RESUME_VIDEOS_PROPERTY,
	AUDIENCE_SETTINGS_LAST_PLAYED_VIDEOS_PROPERTY,
	AUDIENCE_SETTINGS_CURRENT_VIDEO_PROPERTY,
	AUDIENCE_SETTINGS_LAST_STOPPED_PROPERTY,
	AUDIENCE_SETTINGS_LAST_FOLDER_PROPERTY,
	AUDIENCE_SETTINGS_PLAYBACK_WAIT_PROPERTY,
	AUDIENCE_SETTINGS_STAY_ON_TOP_PROPERTY,
	AUDIENCE_SETTINGS_SUBTITLE_FONT_PROPERTY,
	AUDIENCE_SETTINGS_LIBRARY_FOLDER_PROPERTY,
	AUDIENCE_SETTINGS_POSTER_NAMES_PROPERTY,
	AUDIENCE_SETTINGS_NUM_PROPERTIES
};
static GParamSpec* audience_settings_properties[AUDIENCE_SETTINGS_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))

struct _AudienceSettings {
	GraniteServicesSettings parent_instance;
	AudienceSettingsPrivate * priv;
};

struct _AudienceSettingsClass {
	GraniteServicesSettingsClass parent_class;
};

struct _AudienceSettingsPrivate {
	gboolean _move_window;
	gboolean _keep_aspect;
	gboolean _resume_videos;
	gchar** _last_played_videos;
	gint _last_played_videos_length1;
	gint __last_played_videos_size_;
	gchar* _current_video;
	gdouble _last_stopped;
	gchar* _last_folder;
	gboolean _playback_wait;
	gboolean _stay_on_top;
	gchar* _subtitle_font;
	gchar* _library_folder;
	gchar** _poster_names;
	gint _poster_names_length1;
	gint __poster_names_size_;
};


static gint AudienceSettings_private_offset;
static gpointer audience_settings_parent_class = NULL;

GType audience_settings_get_type (void) G_GNUC_CONST;
AudienceSettings* audience_settings_new (void);
AudienceSettings* audience_settings_construct (GType object_type);
gboolean audience_settings_get_move_window (AudienceSettings* self);
void audience_settings_set_move_window (AudienceSettings* self,
                                        gboolean value);
gboolean audience_settings_get_keep_aspect (AudienceSettings* self);
void audience_settings_set_keep_aspect (AudienceSettings* self,
                                        gboolean value);
gboolean audience_settings_get_resume_videos (AudienceSettings* self);
void audience_settings_set_resume_videos (AudienceSettings* self,
                                          gboolean value);
gchar** audience_settings_get_last_played_videos (AudienceSettings* self,
                                                  int* result_length1);
void audience_settings_set_last_played_videos (AudienceSettings* self,
                                               gchar** value,
                                               int value_length1);
static gchar** _vala_array_dup1 (gchar** self,
                          int length);
const gchar* audience_settings_get_current_video (AudienceSettings* self);
void audience_settings_set_current_video (AudienceSettings* self,
                                          const gchar* value);
gdouble audience_settings_get_last_stopped (AudienceSettings* self);
void audience_settings_set_last_stopped (AudienceSettings* self,
                                         gdouble value);
const gchar* audience_settings_get_last_folder (AudienceSettings* self);
void audience_settings_set_last_folder (AudienceSettings* self,
                                        const gchar* value);
gboolean audience_settings_get_playback_wait (AudienceSettings* self);
void audience_settings_set_playback_wait (AudienceSettings* self,
                                          gboolean value);
gboolean audience_settings_get_stay_on_top (AudienceSettings* self);
void audience_settings_set_stay_on_top (AudienceSettings* self,
                                        gboolean value);
const gchar* audience_settings_get_subtitle_font (AudienceSettings* self);
void audience_settings_set_subtitle_font (AudienceSettings* self,
                                          const gchar* value);
const gchar* audience_settings_get_library_folder (AudienceSettings* self);
void audience_settings_set_library_folder (AudienceSettings* self,
                                           const gchar* value);
gchar** audience_settings_get_poster_names (AudienceSettings* self,
                                            int* result_length1);
void audience_settings_set_poster_names (AudienceSettings* self,
                                         gchar** value,
                                         int value_length1);
static gchar** _vala_array_dup2 (gchar** self,
                          int length);
static void audience_settings_finalize (GObject * obj);
static void _vala_audience_settings_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec);
static void _vala_audience_settings_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);


static inline gpointer
audience_settings_get_instance_private (AudienceSettings* self)
{
	return G_STRUCT_MEMBER_P (self, AudienceSettings_private_offset);
}


AudienceSettings*
audience_settings_construct (GType object_type)
{
	AudienceSettings * self = NULL;
	self = (AudienceSettings*) granite_services_settings_construct (object_type, "io.elementary.videos");
	return self;
}


AudienceSettings*
audience_settings_new (void)
{
	return audience_settings_construct (AUDIENCE_TYPE_SETTINGS);
}


gboolean
audience_settings_get_move_window (AudienceSettings* self)
{
	gboolean result;
	gboolean _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_move_window;
	result = _tmp0_;
	return result;
}


void
audience_settings_set_move_window (AudienceSettings* self,
                                   gboolean value)
{
	g_return_if_fail (self != NULL);
	if (audience_settings_get_move_window (self) != value) {
		self->priv->_move_window = value;
		g_object_notify_by_pspec ((GObject *) self, audience_settings_properties[AUDIENCE_SETTINGS_MOVE_WINDOW_PROPERTY]);
	}
}


gboolean
audience_settings_get_keep_aspect (AudienceSettings* self)
{
	gboolean result;
	gboolean _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_keep_aspect;
	result = _tmp0_;
	return result;
}


void
audience_settings_set_keep_aspect (AudienceSettings* self,
                                   gboolean value)
{
	g_return_if_fail (self != NULL);
	if (audience_settings_get_keep_aspect (self) != value) {
		self->priv->_keep_aspect = value;
		g_object_notify_by_pspec ((GObject *) self, audience_settings_properties[AUDIENCE_SETTINGS_KEEP_ASPECT_PROPERTY]);
	}
}


gboolean
audience_settings_get_resume_videos (AudienceSettings* self)
{
	gboolean result;
	gboolean _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_resume_videos;
	result = _tmp0_;
	return result;
}


void
audience_settings_set_resume_videos (AudienceSettings* self,
                                     gboolean value)
{
	g_return_if_fail (self != NULL);
	if (audience_settings_get_resume_videos (self) != value) {
		self->priv->_resume_videos = value;
		g_object_notify_by_pspec ((GObject *) self, audience_settings_properties[AUDIENCE_SETTINGS_RESUME_VIDEOS_PROPERTY]);
	}
}


gchar**
audience_settings_get_last_played_videos (AudienceSettings* self,
                                          int* result_length1)
{
	gchar** result;
	gchar** _tmp0_;
	gint _tmp0__length1;
	gchar** _tmp1_;
	gint _tmp1__length1;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_last_played_videos;
	_tmp0__length1 = self->priv->_last_played_videos_length1;
	_tmp1_ = _tmp0_;
	_tmp1__length1 = _tmp0__length1;
	if (result_length1) {
		*result_length1 = _tmp1__length1;
	}
	result = _tmp1_;
	return result;
}


static gchar**
_vala_array_dup1 (gchar** self,
                  int length)
{
	gchar** result;
	int i;
	result = g_new0 (gchar*, length + 1);
	for (i = 0; i < length; i++) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (self[i]);
		result[i] = _tmp0_;
	}
	return result;
}


void
audience_settings_set_last_played_videos (AudienceSettings* self,
                                          gchar** value,
                                          int value_length1)
{
	int old_value_length;
	g_return_if_fail (self != NULL);
	if (audience_settings_get_last_played_videos (self, &old_value_length) != value) {
		gchar** _tmp0_;
		gint _tmp0__length1;
		_tmp0_ = (value != NULL) ? _vala_array_dup1 (value, value_length1) : ((gpointer) value);
		_tmp0__length1 = value_length1;
		self->priv->_last_played_videos = (_vala_array_free (self->priv->_last_played_videos, self->priv->_last_played_videos_length1, (GDestroyNotify) g_free), NULL);
		self->priv->_last_played_videos = _tmp0_;
		self->priv->_last_played_videos_length1 = _tmp0__length1;
		self->priv->__last_played_videos_size_ = self->priv->_last_played_videos_length1;
		g_object_notify_by_pspec ((GObject *) self, audience_settings_properties[AUDIENCE_SETTINGS_LAST_PLAYED_VIDEOS_PROPERTY]);
	}
}


const gchar*
audience_settings_get_current_video (AudienceSettings* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_current_video;
	result = _tmp0_;
	return result;
}


void
audience_settings_set_current_video (AudienceSettings* self,
                                     const gchar* value)
{
	g_return_if_fail (self != NULL);
	if (g_strcmp0 (value, audience_settings_get_current_video (self)) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_current_video);
		self->priv->_current_video = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, audience_settings_properties[AUDIENCE_SETTINGS_CURRENT_VIDEO_PROPERTY]);
	}
}


gdouble
audience_settings_get_last_stopped (AudienceSettings* self)
{
	gdouble result;
	gdouble _tmp0_;
	g_return_val_if_fail (self != NULL, 0.0);
	_tmp0_ = self->priv->_last_stopped;
	result = _tmp0_;
	return result;
}


void
audience_settings_set_last_stopped (AudienceSettings* self,
                                    gdouble value)
{
	g_return_if_fail (self != NULL);
	if (audience_settings_get_last_stopped (self) != value) {
		self->priv->_last_stopped = value;
		g_object_notify_by_pspec ((GObject *) self, audience_settings_properties[AUDIENCE_SETTINGS_LAST_STOPPED_PROPERTY]);
	}
}


const gchar*
audience_settings_get_last_folder (AudienceSettings* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_last_folder;
	result = _tmp0_;
	return result;
}


void
audience_settings_set_last_folder (AudienceSettings* self,
                                   const gchar* value)
{
	g_return_if_fail (self != NULL);
	if (g_strcmp0 (value, audience_settings_get_last_folder (self)) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_last_folder);
		self->priv->_last_folder = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, audience_settings_properties[AUDIENCE_SETTINGS_LAST_FOLDER_PROPERTY]);
	}
}


gboolean
audience_settings_get_playback_wait (AudienceSettings* self)
{
	gboolean result;
	gboolean _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_playback_wait;
	result = _tmp0_;
	return result;
}


void
audience_settings_set_playback_wait (AudienceSettings* self,
                                     gboolean value)
{
	g_return_if_fail (self != NULL);
	if (audience_settings_get_playback_wait (self) != value) {
		self->priv->_playback_wait = value;
		g_object_notify_by_pspec ((GObject *) self, audience_settings_properties[AUDIENCE_SETTINGS_PLAYBACK_WAIT_PROPERTY]);
	}
}


gboolean
audience_settings_get_stay_on_top (AudienceSettings* self)
{
	gboolean result;
	gboolean _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_stay_on_top;
	result = _tmp0_;
	return result;
}


void
audience_settings_set_stay_on_top (AudienceSettings* self,
                                   gboolean value)
{
	g_return_if_fail (self != NULL);
	if (audience_settings_get_stay_on_top (self) != value) {
		self->priv->_stay_on_top = value;
		g_object_notify_by_pspec ((GObject *) self, audience_settings_properties[AUDIENCE_SETTINGS_STAY_ON_TOP_PROPERTY]);
	}
}


const gchar*
audience_settings_get_subtitle_font (AudienceSettings* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_subtitle_font;
	result = _tmp0_;
	return result;
}


void
audience_settings_set_subtitle_font (AudienceSettings* self,
                                     const gchar* value)
{
	g_return_if_fail (self != NULL);
	if (g_strcmp0 (value, audience_settings_get_subtitle_font (self)) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_subtitle_font);
		self->priv->_subtitle_font = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, audience_settings_properties[AUDIENCE_SETTINGS_SUBTITLE_FONT_PROPERTY]);
	}
}


const gchar*
audience_settings_get_library_folder (AudienceSettings* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_library_folder;
	result = _tmp0_;
	return result;
}


void
audience_settings_set_library_folder (AudienceSettings* self,
                                      const gchar* value)
{
	g_return_if_fail (self != NULL);
	if (g_strcmp0 (value, audience_settings_get_library_folder (self)) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_library_folder);
		self->priv->_library_folder = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, audience_settings_properties[AUDIENCE_SETTINGS_LIBRARY_FOLDER_PROPERTY]);
	}
}


gchar**
audience_settings_get_poster_names (AudienceSettings* self,
                                    int* result_length1)
{
	gchar** result;
	gchar** _tmp0_;
	gint _tmp0__length1;
	gchar** _tmp1_;
	gint _tmp1__length1;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_poster_names;
	_tmp0__length1 = self->priv->_poster_names_length1;
	_tmp1_ = _tmp0_;
	_tmp1__length1 = _tmp0__length1;
	if (result_length1) {
		*result_length1 = _tmp1__length1;
	}
	result = _tmp1_;
	return result;
}


static gchar**
_vala_array_dup2 (gchar** self,
                  int length)
{
	gchar** result;
	int i;
	result = g_new0 (gchar*, length + 1);
	for (i = 0; i < length; i++) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (self[i]);
		result[i] = _tmp0_;
	}
	return result;
}


void
audience_settings_set_poster_names (AudienceSettings* self,
                                    gchar** value,
                                    int value_length1)
{
	int old_value_length;
	g_return_if_fail (self != NULL);
	if (audience_settings_get_poster_names (self, &old_value_length) != value) {
		gchar** _tmp0_;
		gint _tmp0__length1;
		_tmp0_ = (value != NULL) ? _vala_array_dup2 (value, value_length1) : ((gpointer) value);
		_tmp0__length1 = value_length1;
		self->priv->_poster_names = (_vala_array_free (self->priv->_poster_names, self->priv->_poster_names_length1, (GDestroyNotify) g_free), NULL);
		self->priv->_poster_names = _tmp0_;
		self->priv->_poster_names_length1 = _tmp0__length1;
		self->priv->__poster_names_size_ = self->priv->_poster_names_length1;
		g_object_notify_by_pspec ((GObject *) self, audience_settings_properties[AUDIENCE_SETTINGS_POSTER_NAMES_PROPERTY]);
	}
}


static void
audience_settings_class_init (AudienceSettingsClass * klass)
{
	audience_settings_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &AudienceSettings_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_audience_settings_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_audience_settings_set_property;
	G_OBJECT_CLASS (klass)->finalize = audience_settings_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), AUDIENCE_SETTINGS_MOVE_WINDOW_PROPERTY, audience_settings_properties[AUDIENCE_SETTINGS_MOVE_WINDOW_PROPERTY] = g_param_spec_boolean ("move-window", "move-window", "move-window", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), AUDIENCE_SETTINGS_KEEP_ASPECT_PROPERTY, audience_settings_properties[AUDIENCE_SETTINGS_KEEP_ASPECT_PROPERTY] = g_param_spec_boolean ("keep-aspect", "keep-aspect", "keep-aspect", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), AUDIENCE_SETTINGS_RESUME_VIDEOS_PROPERTY, audience_settings_properties[AUDIENCE_SETTINGS_RESUME_VIDEOS_PROPERTY] = g_param_spec_boolean ("resume-videos", "resume-videos", "resume-videos", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), AUDIENCE_SETTINGS_LAST_PLAYED_VIDEOS_PROPERTY, audience_settings_properties[AUDIENCE_SETTINGS_LAST_PLAYED_VIDEOS_PROPERTY] = g_param_spec_boxed ("last-played-videos", "last-played-videos", "last-played-videos", G_TYPE_STRV, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), AUDIENCE_SETTINGS_CURRENT_VIDEO_PROPERTY, audience_settings_properties[AUDIENCE_SETTINGS_CURRENT_VIDEO_PROPERTY] = g_param_spec_string ("current-video", "current-video", "current-video", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), AUDIENCE_SETTINGS_LAST_STOPPED_PROPERTY, audience_settings_properties[AUDIENCE_SETTINGS_LAST_STOPPED_PROPERTY] = g_param_spec_double ("last-stopped", "last-stopped", "last-stopped", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), AUDIENCE_SETTINGS_LAST_FOLDER_PROPERTY, audience_settings_properties[AUDIENCE_SETTINGS_LAST_FOLDER_PROPERTY] = g_param_spec_string ("last-folder", "last-folder", "last-folder", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), AUDIENCE_SETTINGS_PLAYBACK_WAIT_PROPERTY, audience_settings_properties[AUDIENCE_SETTINGS_PLAYBACK_WAIT_PROPERTY] = g_param_spec_boolean ("playback-wait", "playback-wait", "playback-wait", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), AUDIENCE_SETTINGS_STAY_ON_TOP_PROPERTY, audience_settings_properties[AUDIENCE_SETTINGS_STAY_ON_TOP_PROPERTY] = g_param_spec_boolean ("stay-on-top", "stay-on-top", "stay-on-top", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), AUDIENCE_SETTINGS_SUBTITLE_FONT_PROPERTY, audience_settings_properties[AUDIENCE_SETTINGS_SUBTITLE_FONT_PROPERTY] = g_param_spec_string ("subtitle-font", "subtitle-font", "subtitle-font", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), AUDIENCE_SETTINGS_LIBRARY_FOLDER_PROPERTY, audience_settings_properties[AUDIENCE_SETTINGS_LIBRARY_FOLDER_PROPERTY] = g_param_spec_string ("library-folder", "library-folder", "library-folder", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), AUDIENCE_SETTINGS_POSTER_NAMES_PROPERTY, audience_settings_properties[AUDIENCE_SETTINGS_POSTER_NAMES_PROPERTY] = g_param_spec_boxed ("poster-names", "poster-names", "poster-names", G_TYPE_STRV, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
}


static void
audience_settings_instance_init (AudienceSettings * self)
{
	self->priv = audience_settings_get_instance_private (self);
}


static void
audience_settings_finalize (GObject * obj)
{
	AudienceSettings * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, AUDIENCE_TYPE_SETTINGS, AudienceSettings);
	self->priv->_last_played_videos = (_vala_array_free (self->priv->_last_played_videos, self->priv->_last_played_videos_length1, (GDestroyNotify) g_free), NULL);
	_g_free0 (self->priv->_current_video);
	_g_free0 (self->priv->_last_folder);
	_g_free0 (self->priv->_subtitle_font);
	_g_free0 (self->priv->_library_folder);
	self->priv->_poster_names = (_vala_array_free (self->priv->_poster_names, self->priv->_poster_names_length1, (GDestroyNotify) g_free), NULL);
	G_OBJECT_CLASS (audience_settings_parent_class)->finalize (obj);
}


GType
audience_settings_get_type (void)
{
	static volatile gsize audience_settings_type_id__volatile = 0;
	if (g_once_init_enter (&audience_settings_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (AudienceSettingsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) audience_settings_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (AudienceSettings), 0, (GInstanceInitFunc) audience_settings_instance_init, NULL };
		GType audience_settings_type_id;
		audience_settings_type_id = g_type_register_static (GRANITE_SERVICES_TYPE_SETTINGS, "AudienceSettings", &g_define_type_info, 0);
		AudienceSettings_private_offset = g_type_add_instance_private (audience_settings_type_id, sizeof (AudienceSettingsPrivate));
		g_once_init_leave (&audience_settings_type_id__volatile, audience_settings_type_id);
	}
	return audience_settings_type_id__volatile;
}


static void
_vala_audience_settings_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec)
{
	AudienceSettings * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, AUDIENCE_TYPE_SETTINGS, AudienceSettings);
	switch (property_id) {
		case AUDIENCE_SETTINGS_MOVE_WINDOW_PROPERTY:
		g_value_set_boolean (value, audience_settings_get_move_window (self));
		break;
		case AUDIENCE_SETTINGS_KEEP_ASPECT_PROPERTY:
		g_value_set_boolean (value, audience_settings_get_keep_aspect (self));
		break;
		case AUDIENCE_SETTINGS_RESUME_VIDEOS_PROPERTY:
		g_value_set_boolean (value, audience_settings_get_resume_videos (self));
		break;
		case AUDIENCE_SETTINGS_LAST_PLAYED_VIDEOS_PROPERTY:
		{
			int length;
			g_value_set_boxed (value, audience_settings_get_last_played_videos (self, &length));
		}
		break;
		case AUDIENCE_SETTINGS_CURRENT_VIDEO_PROPERTY:
		g_value_set_string (value, audience_settings_get_current_video (self));
		break;
		case AUDIENCE_SETTINGS_LAST_STOPPED_PROPERTY:
		g_value_set_double (value, audience_settings_get_last_stopped (self));
		break;
		case AUDIENCE_SETTINGS_LAST_FOLDER_PROPERTY:
		g_value_set_string (value, audience_settings_get_last_folder (self));
		break;
		case AUDIENCE_SETTINGS_PLAYBACK_WAIT_PROPERTY:
		g_value_set_boolean (value, audience_settings_get_playback_wait (self));
		break;
		case AUDIENCE_SETTINGS_STAY_ON_TOP_PROPERTY:
		g_value_set_boolean (value, audience_settings_get_stay_on_top (self));
		break;
		case AUDIENCE_SETTINGS_SUBTITLE_FONT_PROPERTY:
		g_value_set_string (value, audience_settings_get_subtitle_font (self));
		break;
		case AUDIENCE_SETTINGS_LIBRARY_FOLDER_PROPERTY:
		g_value_set_string (value, audience_settings_get_library_folder (self));
		break;
		case AUDIENCE_SETTINGS_POSTER_NAMES_PROPERTY:
		{
			int length;
			g_value_set_boxed (value, audience_settings_get_poster_names (self, &length));
		}
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void
_vala_audience_settings_set_property (GObject * object,
                                      guint property_id,
                                      const GValue * value,
                                      GParamSpec * pspec)
{
	AudienceSettings * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, AUDIENCE_TYPE_SETTINGS, AudienceSettings);
	switch (property_id) {
		case AUDIENCE_SETTINGS_MOVE_WINDOW_PROPERTY:
		audience_settings_set_move_window (self, g_value_get_boolean (value));
		break;
		case AUDIENCE_SETTINGS_KEEP_ASPECT_PROPERTY:
		audience_settings_set_keep_aspect (self, g_value_get_boolean (value));
		break;
		case AUDIENCE_SETTINGS_RESUME_VIDEOS_PROPERTY:
		audience_settings_set_resume_videos (self, g_value_get_boolean (value));
		break;
		case AUDIENCE_SETTINGS_LAST_PLAYED_VIDEOS_PROPERTY:
		{
			gpointer boxed;
			boxed = g_value_get_boxed (value);
			audience_settings_set_last_played_videos (self, boxed, (boxed == NULL) ? 0 : g_strv_length (boxed));
		}
		break;
		case AUDIENCE_SETTINGS_CURRENT_VIDEO_PROPERTY:
		audience_settings_set_current_video (self, g_value_get_string (value));
		break;
		case AUDIENCE_SETTINGS_LAST_STOPPED_PROPERTY:
		audience_settings_set_last_stopped (self, g_value_get_double (value));
		break;
		case AUDIENCE_SETTINGS_LAST_FOLDER_PROPERTY:
		audience_settings_set_last_folder (self, g_value_get_string (value));
		break;
		case AUDIENCE_SETTINGS_PLAYBACK_WAIT_PROPERTY:
		audience_settings_set_playback_wait (self, g_value_get_boolean (value));
		break;
		case AUDIENCE_SETTINGS_STAY_ON_TOP_PROPERTY:
		audience_settings_set_stay_on_top (self, g_value_get_boolean (value));
		break;
		case AUDIENCE_SETTINGS_SUBTITLE_FONT_PROPERTY:
		audience_settings_set_subtitle_font (self, g_value_get_string (value));
		break;
		case AUDIENCE_SETTINGS_LIBRARY_FOLDER_PROPERTY:
		audience_settings_set_library_folder (self, g_value_get_string (value));
		break;
		case AUDIENCE_SETTINGS_POSTER_NAMES_PROPERTY:
		{
			gpointer boxed;
			boxed = g_value_get_boxed (value);
			audience_settings_set_poster_names (self, boxed, (boxed == NULL) ? 0 : g_strv_length (boxed));
		}
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



